#ifndef ITALIANO
// English version
#define M_SEPARATOR "====================================================================\r\n"
#define M_SEPARATOR1 "====================================================================\n"
#define E_TNF "TABLES.DAT file not found"
#define E_PDFNOTOPENED "You must open a PDF file."
#define E_QRYPARSE "Error(s) while parsing query file."
#define E_QRYTITLE "Errors in query file"
#define E_PDFPARSE "Error(s) while parsing PDF file."
#define E_PDFTITLE "Errors in PDF file"
#define E_QRYTITLE1 "Query results: "
#define E_LOGTITLE "CaptureFile: "
#define E_NUMDATA "Errors in numeric data. Assuming old values."
#define E_RDATTR "Error reading attributes"
#define E_CLOSELOG "Close this before opening another."
#define E_SAVEFAIL "Warning: File save-as failed.\n"
#define E_NOMEM "Out of memory"
#define A_CLOSELOG "Are you sure to close this capture file?"
#define A_REDQRY "Do you want to reduce the Group Number?"
#define A_QRYCOMMENT "; User defined comments"
#define A_QRYNEW "NewQuery.qry"
#define A_ANALIZERHLP "Analyzer.chm"
#define A_PDFFILE "default.pdf"
#define R_RAPNUM "\r\nReport Number : %d\r\n"
#define R_RAPLOG "CapFile : "
#define E_REPCLOSE "Errors closing Report File"
#define E_REPOPEN "Errors opening Report File"


#define Q_ANALIZING     "Analyzing capture file %s"
#define QE_EOF          "file is empty"
#define QE_FORMAT       "file is invalid"
#define QE_TRUNC        "file is "
#define QE_IF           "file is "
#define QE_CR           "file is "
#define QE_DEFAULT      "Suspicious error occured reading capture file - internal error"
#define QE_EOF1         "end of file reached"
#define QE_FORMAT1      "format error encountered"
#define QE_TRUNC1       "file was truncated"
#define QE_UEO1         "uninterpretable error occurred"
#define QE_END1         "Ending analysis because %s"
#define QE_NOTABGEN     "%s ,no table generated"
#define QE_INFO         "The following information will be present in the table\'s cells"
#define QE_NUM          " The number of frames"
#define QE_FR           " The frame rate in frames per second"
#define QE_NF           " The number of frames as percentage of all frames"
#define QE_NB           " The number of bytes"
#define QE_DR           " The data rate in bytes per second"
#define QE_DRP          " The data rate as percentage of the data rate"
#define QE_AFS          " The average frame size in bytes"
#define QE_GROUPS       "The following groups (columns) were defined"
#define QE_TIMEGR       "time\\gr."
#define QE_GRP          " Group %3u%c"
#define QE_TOT          " Totals "
#define QE_AVG          "Averages"
#define QE_MAX          "Maximums"
#define QE_MIN          "Minumums"
#define QE_ABSMAX       "Abs.max."
#define QE_ABSMIN       "Abs.min."

#define RE_OK "NoError"
#define RE_OPFAIL "OpenFailure"
#define RE_UEOF "UnexpectedEndOfFile"
#define RE_LTL "LineTooLong"
#define RE_NUMEXP "NumberExpected"
#define RE_UEOLN "UnexpectedEndOfLine"
#define RE_RPE "RigthPharanthesisExpected"
#define RE_WE "WordExpected"
#define RE_LSBE "LeftSquareBracketExpected"
#define RE_RSBE "RightSquareBracketExpected"
#define RE_NUT7E "NumberUpTo7Expected"
#define RE_CE "CommaExpected"
#define RE_WTL "WordTooLong"
#define RE_BEE "BooleanExpressionExpected"
#define RE_EOLTOE "EqualOrLessThanOperatorExpected"
#define RE_SEE "StringExpressionExpected"
#define RE_HDE "HexadecimalDigitExpected"
#define RE_STL "StringTooLong"
#define RE_WDS "WrongDecimalString"
#define RE_PE "PeriodExpected"
#define RE_WES "WrongEscapeSequence"
#define RE_IN "InvalidNumber"
#define RE_UBP "UnknownBooleanParameter"
#define RE_USP "UnknownStringParameter"
#define RE_UIP "UnknownIntegerParameter"
#define RE_IEE "IntegerExpressionExpected"
#define RE_AOE "ArithmeticOperatorExpected"
#define RE_UE "Unknown error"
#define RE_SYNERR "Syntax error in line %d : %s"
#define RE_PAD "ParameterAlreadyDefined"
#define RE_TMPD "TooManyParametersDefined"
#define RE_INCE "IncorrectExpression"
#define RE_INCF "IncorrectFormula"
#define RE_INVPN "InvalidParameterName"
#define RE_INVF "InvalidFunction - internal error"
#define RE_UNKNOWN "Unknown error - internal error"
#define RE_ERRDEF "Error defining %s in line %u : %s"
#define RE_ERRRDF "Errors occured reading definition file %s at %s"
#define RE_ERROF "Error opening file"
#define RE_TOOLONG "Line %d totally ignored because is too long"
#define RE_INVLINE "Invalid line encountered (%d)"
#define RE_INVDEFINE "Invalid define (%s) in line %d"
#define RE_UNEXPEOF "Unexpected EOF"
#define RE_BADKEY "Bad keyword in line %u, %s expected"
#define RE_EQNF "The \"=\" not found in the line defining %s"
#define RE_BADYN "Value of %s must be \"Yes\" or \"No\" can't accept \"%s\""
#define RE_BADTIMEFMT "Incorrect time format in line %u"
#define RE_TOOGRPS "Too many groups defined (%u) table would be too wide"
#define RE_ERRQRY "Errors occured reading query file %s at %s"

#define RP_EMLOG "Error moving through Capture file"
#define RP_NOPARLD "No parameter definitions loaded"
#define RP_ERRFLT "Error in filter, position %d, code %s"
#define RP_EOF "End Of File reached"
#define RP_BOF "Begin Of File reached"

#else

// Versione ITALIANA
#define M_SEPARATOR "====================================================================\r\n"
#define M_SEPARATOR1 "====================================================================\n"
#define E_TNF "Il file TABLES.DAT non e' stato trovato"
#define E_PDFNOTOPENED "Si deve aprire un file PDF."
#define E_QRYPARSE "Riscontrato(i) errore(i) mentre si esaminava un file di Statistiche."
#define E_QRYTITLE "Errori nel file di Statistiche"
#define E_PDFPARSE "Error(s) while parsing PDF file."
#define E_PDFTITLE "Riscontrato(i) errore(i) mentre si esaminava un file PDF"
#define E_QRYTITLE1 "Risultati delle Statistiche: "
#define E_LOGTITLE "File di Log: "
#define E_NUMDATA "Valori numerici errati. Si useranno quelli vecchi."
#define E_RDATTR "Errori durante la lettura degli attributi"
#define E_CLOSELOG "Chiudere questo prima di aprirne un altro."
#define E_SAVEFAIL "Attenzione: File salva-con-nome fallito.\n"
#define E_NOMEM "Memoria Esaurita"
#define A_CLOSELOG "Si vuole veramente chiudere questo file di LOG?"
#define A_REDQRY "Si vuole veramente ridurre il numero di gruppi?"
#define A_QRYCOMMENT "; Commenti definiti dall'utente"
#define A_QRYNEW "NuoveStatistiche.qry"
#define A_ANALIZERHLP "Analyzer.chm"
#define A_PDFFILE "default.pdf"
#define R_RAPNUM "\r\nRapporto Numero : %d\r\n"
#define R_RAPLOG "CAPFile : "
#define E_REPCLOSE "Problemi nella chiusura del Rapporto"
#define E_REPOPEN "Problemi nell'apertura del file Rapporto"


#define Q_ANALIZING     "Analisi del file di cattura: %s"
#define QE_EOF          "Il file e' vuoto"
#define QE_FORMAT       "Il file non e' valido"
#define QE_TRUNC        "Il file e'... "
#define QE_IF           "Il file e'... "
#define QE_CR           "Il file e'... "
#define QE_DEFAULT      "Errore sospetto durante la lettura del capture file - errore interno"
#define QE_EOF1         "raggiunta la fine del file"
#define QE_FORMAT1      "errore di formato"
#define QE_TRUNC1       "file troncato"
#define QE_UEO1         "errore ininterpretabile"
#define QE_END1         "Analisi conclusa a causa di: %s"
#define QE_NOTABGEN     "%s ,non e' stata generata alcuna tabella"
#define QE_INFO         "Le seguenti informazioni saranno presenti nelle celle della tabella:"
#define QE_NUM          " Il numero di frames"
#define QE_FR           " Il frame rate in frames al secondo"
#define QE_NF           " Il numero di frames come percentuale di tutti i frames"
#define QE_NB           " Il numero di bytes"
#define QE_DR           " Il data rate in bytes al second"
#define QE_DRP          " Il data rate in percentuale del data rate"
#define QE_AFS          " La dimensione media dei frames in bytes"
#define QE_GROUPS       "I seguenti gruppi (colonne) sono stati definiti"
#define QE_TIMEGR       "tempo\\g."
#define QE_GRP          "Gruppo %3u%c"
#define QE_TOT          " Totali "
#define QE_AVG          " Medie  "
#define QE_MAX          " Massimi"
#define QE_MIN          " Minimi "
#define QE_ABSMAX       "Max.Ass."
#define QE_ABSMIN       "Min.Ass."

#define RE_OK "NoError"
#define RE_OPFAIL "OpenFailure"
#define RE_UEOF "UnexpectedEndOfFile"
#define RE_LTL "LineTooLong"
#define RE_NUMEXP "NumberExpected"
#define RE_UEOLN "UnexpectedEndOfLine"
#define RE_RPE "RigthPharanthesisExpected"
#define RE_WE "WordExpected"
#define RE_LSBE "LeftSquareBracketExpected"
#define RE_RSBE "RightSquareBracketExpected"
#define RE_NUT7E "NumberUpTo7Expected"
#define RE_CE "CommaExpected"
#define RE_WTL "WordTooLong"
#define RE_BEE "BooleanExpressionExpected"
#define RE_EOLTOE "EqualOrLessThanOperatorExpected"
#define RE_SEE "StringExpressionExpected"
#define RE_HDE "HexadecimalDigitExpected"
#define RE_STL "StringTooLong"
#define RE_WDS "WrongDecimalString"
#define RE_PE "PeriodExpected"
#define RE_WES "WrongEscapeSequence"
#define RE_IN "InvalidNumber"
#define RE_UBP "UnknownBooleanParameter"
#define RE_USP "UnknownStringParameter"
#define RE_UIP "UnknownIntegerParameter"
#define RE_IEE "IntegerExpressionExpected"
#define RE_AOE "ArithmeticOperatorExpected"
#define RE_UE "Unknown error"
#define RE_SYNERR "Syntax error in line %d : %s"
#define RE_PAD "ParameterAlreadyDefined"
#define RE_TMPD "TooManyParametersDefined"
#define RE_INCE "IncorrectExpression"
#define RE_INCF "IncorrectFormula"
#define RE_INVPN "InvalidParameterName"
#define RE_INVF "InvalidFunction - internal error"
#define RE_UNKNOWN "Unknown error - internal error"
#define RE_ERRDEF "Errore nella definizione di  %s nella linea %u : %s"
#define RE_ERRRDF "  Errori incontrati leggendo il file di definizione %s alla %s"
#define RE_ERROF "Errore di apertura del file"
#define RE_TOOLONG "Linea %d ignorata perche' troppo lunga"
#define RE_INVLINE "Incontrata una linea non valida (%d)"
#define RE_INVDEFINE "define non valida (%s) nella linea %d"
#define RE_UNEXPEOF "EOF inatteso"
#define RE_BADKEY "Keyword sconosciuta nella linea %u, %s inatteso"
#define RE_EQNF "Un \"=\" non e' stato trovato nella linea che definisce %s"
#define RE_BADYN "Il valore di %s pu errere \"Yes\" o \"No\". Non e' valido il valore \"%s\""
#define RE_BADTIMEFMT "Formato errato del tempo nella linea %u"
#define RE_TOOGRPS "Troppi gruppi definiti (%u) la tabella sarebbe troppo larga"
#define RE_ERRQRY "  Errori nella lettura del file di Statistiche %s nella posizione %s"

#define RP_EMLOG "Errore muovendosi nel file di catture"
#define RP_NOPARLD "Non e' stato caricato un file PDF"
#define RP_ERRFLT "Filtro errato, posizione %d, codice %s"
#define RP_EOF "Raggiunto l'End Of File"
#define RP_BOF "Raggiunto il Begin Of File"


#endif